=== debian/changelog ===
pmdk (1.13.1-1.1ubuntu3) questing; urgency=medium

  * d/rules: disable the GCS warning on arm64 (LP: #2119445)

 -- Andreas Hasenack <andreas@canonical.com>  Wed, 24 Sep 2025 17:06:49 -0300

pmdk (1.13.1-1.1ubuntu2) noble; urgency=medium

  * Fix FTBFS issues in ppc64el:
    - d/rules: skip ppc64el build time tests
    - d/p/debian-changes: remove bogus file

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Thu, 18 Apr 2024 09:44:59 -0300

pmdk (1.13.1-1.1ubuntu1) noble; urgency=medium

  * d/rules: Disable TEST5 on ppc64el to fix FTBFS
    (LP: #2061913)

 -- Bryce Harrington <bryce@canonical.com>  Tue, 16 Apr 2024 16:17:03 -0700

pmdk (1.13.1-1.1build1) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:15:44 +0200

pmdk (1.13.1-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Ignore check-manpages failure until Pandoc creates manpages
    that are accepted by the latest groff. (Closes: #1042252)

 -- Adrian Bunk <bunk@debian.org>  Fri, 11 Aug 2023 13:28:04 +0300

pmdk (1.13.1-1) unstable; urgency=medium

  * New upstream release.
  * Replace the old team's gpg keys by Oksana's.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 05 Jun 2023 11:32:46 +0200

pmdk (1.13.1~rc2-1) experimental; urgency=medium

  * New upstream RC.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 29 May 2023 10:31:42 +0200

pmdk (1.13.0-1) experimental; urgency=medium

  * New upstream release.
  * A watch file that uses the Github API -- with working .asc.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 28 Apr 2023 15:42:14 +0200

pmdk (1.13.0~rc1-1) experimental; urgency=medium

  * New upstream RC.
  * Add luke's gpg key.
  * Enable loong64 -- completely untested.
  * Let the watch file find -rc tags.
  * Temporarily disable checking upstream gpg.
  * Drop autopkgtests for deprecated libpmem{blk,log}.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 22 Apr 2023 21:12:44 +0200
